/*
    Edge.h

    You shouldn't need to play with this file.
*/



// An Edge has two vertices
// The Edge object has the screen space and  eye space coordinates and
// eye space normals of the vertices of an edge
// Also it contains the start and end color of the polygon
class Edge {
public:

  // Constructor
  Edge () {poly = NULL;}

  // Requires: p0, p1 to be the correct polygon vertices
  //           p to be the pointer to the corresponding polygon
  // Modifies: ss, es, col, p
  // Effect:   Sets up the edge
  void Init (PolyVert &p0, PolyVert &p1, Polygon* p) {
    ss[0] = p0.sspt;  ss[1] = p1.sspt;
    assert ((ss[1][Y] > ss[0][Y]) ||
	    ((ss[1][Y] == ss[0][Y]) && ss[1][X] >= ss[0][X]));
    es[0] = p0.espt; es[1] = p1.espt;
    col[0] = p0.col; col[1] = p1.col;
    norm[0] = p0.norm; norm[1] = p1.norm;
    poly = p;
  }

  // Screen space coordinates 
  Point2D        ss[2];
  // Eye space coordinates
  Point          es[2];
  // Color 
  Color          col[2];
  // Normal
  Vector         norm[2];
  // Polygon 
  Polygon        *poly;
};
