/*
  The EdgeRecList is a list of EdgeRecs.

  The AEL is a special form of this.

  Luke Weisman
*/
#ifndef __EDGERECLIST__
#define __EDGERECLIST__

#include "List.h"

// The EdgeRecList
// EdgeRecList stores the head of the EdgeRec list 
class EdgeRecList : public CLinkList<EdgeRec> {

public:  
  // Constructor 
  EdgeRecList () {}

  // Effect: Prints the EdgeRec List
  //         Useful for debugging 
  // Modifies: none
  // Requires: 
  void PrintList ();

  // Effect: Sorts the EdgeRecList pointed to by head
  //         Sort is done on xcurr
  // Modifies: potentially *head can be changed
  // Requires: 
  void Sort ();

  // Requires: line, the new line number
  // Modifies: head
  // Effects:  Updates all of the edges in the AEL for the new line.
  //           Then it removes those that end on this scan line. 
  //           or, on other words:
  //           Advance to next y-value.  Chuck expired edges. 
  void Update( int line );

  //Find next edge on list that belongs to poly
  //Does not modify current edge
  EdgeRec * NextPolyEdge (Polygon * poly);

}; // end class EdgeRecList

#endif
